package com.sktechx.tacademy.arduinoclient;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

public class MainActivity extends AppCompatActivity {
    Button buzzerButton;
    Spinner spinner;
    ListView listView;
    boolean bBuzzer = false;
    class DHT11 {
        float temp; float humidity;
    }
    class CDS {
        int value;
    }
    ArrayList<DHT11> dht11LogList = new ArrayList<DHT11>();
    ArrayList<CDS> cdsLogList = new ArrayList<CDS>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        buzzerButton = (Button)findViewById(R.id.buzzer_button);
        spinner = (Spinner)findViewById(R.id.spinner);
        listView = (ListView)findViewById(R.id.listview);
        buzzerButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new LoadSensorLogs().execute("BUZZER");
                /*bBuzzer = !bBuzzer;
                if (bBuzzer) buzzerButton.setText("BUZZER OFF");
                else buzzerButton.setText("BUZZER ON");*/
            }
        });
        String[] sensorList = { "dht11", "cds" };
        ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(MainActivity.this,
                android.R.layout.simple_list_item_1, sensorList);
        spinner.setAdapter(spinnerAdapter);
        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                //Toast.makeText(MainActivity.this, position+"", Toast.LENGTH_SHORT).show();
                new LoadSensorLogs().execute(position+"");
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {}
        });
    }
    class LoadSensorLogs extends AsyncTask<String,String,String> {
        String type = "";
        @Override
        protected String doInBackground(String... params) {//백그라운드 작업 수행 (네트워크 통신)
            String result = "";
            type = params[0];
            dht11LogList.clear();
            cdsLogList.clear();
            String urlString = "http://192.168.0.18:3000/";
            if (params[0].equals("1")) {//CDS를 선택할때
                urlString = "http://192.168.0.18:3000/cds";
            } else if (params[0].equals("BUZZER")) {//BUZZER 버튼 클릭시
                urlString = "http://192.168.0.18:3000/buzzer";
            }
            try {
                URL url = new URL(urlString);
                HttpURLConnection conn = (HttpURLConnection)url.openConnection();//Restful API 서버에 요청 전송
                InputStream is = conn.getInputStream();//서버로부터 응답 수신 시작
                BufferedReader streamReader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
                StringBuilder responseStrBuilder = new StringBuilder();
                String inputStr;
                while((inputStr = streamReader.readLine())!= null)//한줄씩 읽어서 빌더객체에 추가
                    responseStrBuilder.append(inputStr);
                result = responseStrBuilder.toString();//빌더객체를 JSON 문자열로 변환
            } catch(Exception e) {
                e.printStackTrace();
            }
            return result;//서버에서 수신한 JSON 문자열을 리턴
        }
        @Override
        protected void onPostExecute(String result) {
            //Toast.makeText(MainActivity.this, result, Toast.LENGTH_SHORT).show();
            if (type.equals("0")) {//DHT11
                try {
                    JSONArray logList = new JSONArray(result);
                    //Toast.makeText(MainActivity.this, logList.length()+"", Toast.LENGTH_SHORT).show();
                    String[] logTextList = new String[logList.length()];
                    for (int i = 0; i < logList.length(); i++) {
                        JSONObject object = (JSONObject)logList.get(i);
                        DHT11 dht11 = new DHT11();
                        dht11.temp = (float)object.getDouble("temp");
                        dht11.humidity = (float)object.getDouble("humidity");
                        dht11LogList.add(dht11);
                        logTextList[i] = "temp:"+dht11.temp+" humidity:"+dht11.humidity;
                    }
                    ArrayAdapter<String> adapter = new ArrayAdapter<String>(MainActivity.this,
                            android.R.layout.simple_list_item_1, logTextList);
                    listView.setAdapter(adapter);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else if (type.equals("1")) {//CDS
                try {
                    JSONArray logList = new JSONArray(result);
                    //Toast.makeText(MainActivity.this, logList.length()+"", Toast.LENGTH_SHORT).show();
                    String[] logTextList = new String[logList.length()];
                    for (int i = 0; i < logList.length(); i++) {
                        JSONObject object = (JSONObject)logList.get(i);
                        CDS cds = new CDS();
                        cds.value = object.getInt("value");
                        cdsLogList.add(cds);
                        logTextList[i] = "cds value:"+cds.value;
                    }
                    ArrayAdapter<String> adapter = new ArrayAdapter<String>(MainActivity.this,
                            android.R.layout.simple_list_item_1, logTextList);
                    listView.setAdapter(adapter);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else if (type.equals("BUZZER")) {//BUZZER
                try {
                    JSONObject object = new JSONObject(result);
                    boolean buzzer = object.getBoolean("buzzer");
                    if (buzzer) buzzerButton.setText("BUZZER OFF");
                    else buzzerButton.setText("BUZZER ON");
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
